﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using ICSharpCode.SharpZipLib.Zip;
using System.IO;
using System.Windows.Resources;
using System.Windows.Media.Imaging;

namespace WindowsPhoneApplication1
{
    public partial class MainPage : PhoneApplicationPage
    {
        ZipFile _zipfile = null;
        int _fileIndex = -1;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            StreamResourceInfo zipStreamResource = Application.GetResourceStream(new Uri("SamplePictures.zip", UriKind.Relative));
            _zipfile = new ZipFile(zipStreamResource.Stream);

            MoveNextImage();
        }

        private void MoveNextImage()
        {
            if (_fileIndex + 1 < _zipfile.Count)
            {
                _fileIndex++;
                ViewImage();
            }
        }

        private void MovePrevImage()
        {
            if (_fileIndex - 1 >= 0)
            {
                _fileIndex--;
                ViewImage();
            }
        }

        private void ViewImage()
        {
            ZipEntry entry = _zipfile[_fileIndex];
            String entryFileName = entry.Name;
            using (Stream zipStream = _zipfile.GetInputStream(entry))
            {
                byte[] buffer = new byte[4096];
                int readBytes;
                using (MemoryStream mStream = new MemoryStream())
                {
                    do
                    {
                        readBytes = zipStream.Read(buffer, 0, buffer.Length);
                        mStream.Write(buffer, 0, readBytes);

                    } while (readBytes > 0);

                    BitmapImage image = new BitmapImage();
                    image.SetSource(mStream);
                    contentImage.Source = image;

                    mStream.Close();
                }

                zipStream.Close();
            }
        }

        private void nextButton_Click(object sender, RoutedEventArgs e)
        {
            MoveNextImage();
        }

        private void prevButton_Click(object sender, RoutedEventArgs e)
        {
            MovePrevImage();
        }


        //
        // thanks Nick
        // http://nicksnettravels.builttoroam.com/post/2010/06/05/Windows-Phone-7-Data-Json-WCF-Data-Service-with-IIS-7-Compression.aspx
        //

    }
}